/*
 * PSC Changes Copyright (c) 1997 Pittsburgh Supercomputing Center,
 *                     Jeff Semke, Matt Mathis, and Jamshid Mahdavi 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the modifications to this
 * software were developed by the Pittsburgh Supercomputing Center.
 * The name of the Center may not be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE
 * IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE. 
 *
 * @(#) $Header: scoreboard.h,v 1.4 97/03/21 16:53:27 kfall Exp $ (LBL)
 */

//  Definition of the scoreboard class:

#define SBSIZE 1024

class ScoreBoard {
  public:
	ScoreBoard() {first_=0; length_=0;}
	int IsEmpty () {return (length_ == 0);}
	void ClearScoreBoard (); 
	int GetNextRetran ();
	void MarkRetran (int retran_seqno);
	void MarkRetran (int retran_seqno, int snd_nxt);
	int UpdateScoreBoard (int last_ack_, Packet *pkt);
	int CheckSndNxt (Packet *pkt);
	
  protected:
        int first_, length_;
        struct ScoreBoardNode {
		int seq_no_;		/* Packet number */
		int ack_flag_;		/* Acked by cumulative ACK */
		int sack_flag_;		/* Acked by SACK block */
		int retran_;		/* Packet retransmitted */
	        int snd_nxt_;		/* snd_nxt at time of retransmission */
	        int sack_cnt_;          /* number of reports for this hole */
	} SBN[SBSIZE+1];
};

