
#if !defined(_SRM_CTL)
#define _SRM_CTL

class SRMCtl;
class SRM_Agent;

#define SRM_NO_STATE 0
#define SRM_PENDING_REQUEST 1
#define SRM_PENDING_REPAIR 2
#define SRM_REPAIRED 3

class SRMObj {
	friend class SRMCtl;
public:
	SRMObj(double expire, int state, double del, int sn, SRMObj *next) {
		m_expire = expire;
		m_state = state;
		m_delay = del;
		m_seqnum = sn;
		m_next = next;
	};

	virtual void recv_repair(SRMCtl *ctl) = 0;
	virtual void recv_nack(SRMCtl *ctl) = 0;
	virtual void expire(SRMCtl *ctl) = 0;

protected:
	double m_expire;
	double m_delay;
	int m_seqnum;
	int m_state;
	SRMObj *m_next;
};

class SRMCtl {
public:
	SRMCtl(void);
	~SRMCtl(void);
	
	double manage_timers(void);
	void handle_data(int seqnum);
	void handle_nack(int seqnum);
	void handle_repair(int seqnum);
	void reset(void);
	
	inline void agent(SRM_Agent *ag) { m_agent = ag; };
	inline SRM_Agent *agent() { return m_agent; };
	
	SRMObj *cancel(int seqnum);
	void sched(SRMObj *ob, double delay);
	SRMObj *find(int seqnum);
	
private:
	SRM_Agent *m_agent;
	SRMObj *m_list;
	int m_expected_seqnum;
};

#endif /* _SRM_CTL */
