#ifndef ns_srm_h
#define ns_srm_h

#include "agent.h"

#include "srm-ctl.h"

//
// This is a passive sink
//

class SRM_Agent : public Agent {
public:
	SRM_Agent();
	int command(int argc, const char *const *argv);
	void recv(Packet *ptk);
	void send_nack(int sn);
	void send_repair(int sn);

	double request_tmo(void);
	double backoff_tmo(double last);
	double repair_tmo(void);
	double ignore_tmo(void);

	void request_sched_hook(void);
	void repair_sched_hook(void);
	void repaired_hook(int req);
	
protected:
	virtual void timeout(int);

	SRMCtl m_ctl;
	int m_scheduled;

	double m_req_delay;
	double m_rep_delay;
	double m_ignore_delay;
	double m_ignore_const;
	double m_backoff_const;
	double m_c1;
	double m_c2;
	double m_d1;
	double m_d2;
	int m_rep_sz;
	int m_req_sz;

	// stats
	int m_reqs_sched;
	int m_reqs_sent;
	int m_reps_sched;
	int m_reps_sent;
	int m_pend_reqs;
	int m_pend_reps;

	// tcl proc hooks
	char *m_on_req_proc;
	char *m_on_req_sent_proc;
	char *m_on_rep_proc;
	char *m_on_rep_sent_proc;
	char *m_on_repaired_proc;
};

#endif
