# without this, we use the same seed and loss is repeatable across
# invocations
ns random 0

set s0 [ns node]
set r1 [ns node]
set r2 [ns node]
ns_duplex $s0 $r1 1.5Mb 50ms lossy-uniform
ns_duplex $s0 $r2 1.5Mb 50ms lossy-uniform

set src1 [ns agent cbr $s0]
set snk1 [ns agent srm $r1]
set snk2 [ns agent srm $r2]

$snk1 join 33000
$snk2 join 33000
$src1 join 33000
$src1 connect 33000 0
$snk1 connect 33000 0
$snk2 connect 33000 0

# $snk1 proc "puts \"Loss on $snk1, lost \[$snk1 get nlost\] so far\""
# $snk2 proc "puts \"Loss on $snk2\""

ns at 0.0 "$src1 start"

[ns link $s0 $r1] set loss_prob 0.10
# [ns link $s0 $r2] set loss_prob 0.02

set trace [ns trace]
$trace attach [open out.tr w]
foreach link [ns link] {
#    $link trace $trace
}

[ns link $s0 $r1] trace $trace

# $snk1 trace $trace

proc finish file {

	set f [open temp.rands w]
	puts $f "TitleText: $file"
	puts $f "Device: Postscript"
	
	exec rm -f temp.p temp.d 
	exec touch temp.d temp.p
	#
	# split queue/drop events into two separate files.
	# we don't bother checking for the link we're interested in
	# since we know only such events are in our trace file
	#
	exec awk {
		{
			if (($1 == "+" || $1 == "-" ) && \
			    ($5 == "srm-rep" || $5 == "cbr"))\
					print $2, $8 + ($11 % 1500) * 0.01
		}
	} out.tr > temp.p
	exec awk {
		{
			if ($1 == "d")
				print $2, $8 + ($11 % 1500) * 0.01
		}
	} out.tr > temp.d

	puts $f \"packets
	flush $f
	exec cat temp.p >@ $f
	flush $f
	# insert dummy data sets so we get X's for marks in data-set 4
	puts $f [format "\n\"skip-1\n0 1\n\n\"skip-2\n0 1\n\n"]

	puts $f \"drops
	flush $f
	#
	# Repeat the first line twice in the drops file because
	# often we have only one drop and xgraph won't print marks
	# for data sets with only one point.
	#
	exec head -1 temp.d >@ $f
	exec cat temp.d >@ $f
	close $f
	exec xgraph -bb -tk -nl -m -x time -y packet temp.rands &
	
	exit 0
}

#
# run the simulation for 20 simulated seconds
#
ns at 5.0 "$src1 stop"
ns at 20.0 "finish srm.out"
ns run
